// Environment.cpp : implementation file
//

#include "stdafx.h"
#include "daq.h"
#include "Environment.h"
#include "DaqSetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEnvironment property page

IMPLEMENT_DYNCREATE(CEnvironment, CPropertyPage)

CEnvironment::CEnvironment() : CPropertyPage(CEnvironment::IDD)
{
	//{{AFX_DATA_INIT(CEnvironment)
	m_data_dir = _T("");
	m_detFile_dir = _T("");
	m_cb_dir = _T("");
	m_autop_dir = _T("");
	//}}AFX_DATA_INIT


	DaqSetup*       daq = daq->Instance ();
	DaqEnv*         daqEnv = daq->daqEnv ();


	if ( daqEnv != 0 )  {
		daqEnv->getDir (DataDir,    m_data_dir);
		daqEnv->getDir (CtrlBlkDir, m_cb_dir);
		daqEnv->getDir (DetDir,     m_detFile_dir);
		daqEnv->getDir (AutoPilotDir, m_autop_dir);
	}
	else {
		m_data_dir = _T("error");
		m_detFile_dir = _T("error");
		m_cb_dir = _T("error");
	}

}

CEnvironment::~CEnvironment()
{
}

void CEnvironment::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEnvironment)
	DDX_Text(pDX, IDC_EV_DATADIR, m_data_dir);
	DDX_Text(pDX, IDC_EV_DFDIR, m_detFile_dir);
	DDX_Text(pDX, IDC_EV_CBDIR, m_cb_dir);
	DDX_Text(pDX, IDC_EV_AUTOP, m_autop_dir);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEnvironment, CPropertyPage)
	//{{AFX_MSG_MAP(CEnvironment)
	ON_BN_CLICKED(IDC_EV_READDIR, OnEvReaddir)
	ON_BN_CLICKED(IDC_EV_SETDIR, OnEvSetdir)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnvironment message handlers

void CEnvironment::OnEvReaddir() 
{

	UpdateData (TRUE);

	DaqSetup*       daq = daq->Instance ();
	DaqEnv*         daqEnv = daq->daqEnv ();

	daqEnv->getDir (DataDir,      m_data_dir);
	daqEnv->getDir (CtrlBlkDir,   m_cb_dir);
	daqEnv->getDir (DetDir,       m_detFile_dir);
	daqEnv->getDir (AutoPilotDir, m_autop_dir);

	UpdateData (FALSE);

}

void CEnvironment::OnEvSetdir() 
{

	UpdateData (TRUE);

	DaqSetup*       daq = daq->Instance ();
	DaqEnv*         daqEnv = daq->daqEnv ();

	daqEnv->setDir (DataDir,      (char *) (LPCTSTR) m_data_dir);
	daqEnv->setDir (CtrlBlkDir,   (char *) (LPCTSTR) m_cb_dir);
	daqEnv->setDir (DetDir,       (char *) (LPCTSTR) m_detFile_dir);
	daqEnv->setDir (AutoPilotDir, (char *) (LPCTSTR) m_autop_dir);

	UpdateData (FALSE);
	
}
