// daq.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "daq.h"



#include "DaqSetup.h"
#include "Vxi_vme.h"

#include "MainSheet.h"

#include <fstream.h>

ofstream logFile;

extern "C" {
#include <stdio.h>
}



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDaqApp

BEGIN_MESSAGE_MAP(CDaqApp, CWinApp)
	//{{AFX_MSG_MAP(CDaqApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDaqApp construction

CDaqApp::CDaqApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDaqApp object

CDaqApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDaqApp initialization

BOOL CDaqApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif


/*  WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_DAQTYPE,
		RUNTIME_CLASS(CDaqDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CDaqView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();


  WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW */


	// ------------------------------------------
	//    redirect  cout and stdout  to files
	// ------------------------------------------

	
	logFile.open ("outLog_daq.txt", ios::out);
	logFile << " Starting " << endl;


	freopen ("outLog.txt", "w", stdout);


	// ---------------------------------------------
	//     read the default setup from a file
	// ---------------------------------------------
	

	// ---------------------------------------
	//      vxi vme  interface 
	// ---------------------------------------


	Vxi_vme*  vme = vme->Instance ();
	
	if ( vme->init () != 1 )
		return FALSE;


	// -------------------------------------
	//     setup readout configuration
	// -------------------------------------


	DaqSetup*   daq = daq->Instance ();

	logFile << "  env " << endl;

	daq->newDaqEnv ();
	
	logFile << "  read " << endl;

	daq->read_fromFile ("config");

	logFile << "  end init " << endl;

	
	// --------------------------------------------------
	//        open main dialog box
	// --------------------------------------------------

	
	MainSheet	allcontrolssheet(_T("ATLAS DAQ"));
	m_pMainWnd = &allcontrolssheet;
	allcontrolssheet.DoModal();

	return TRUE;

}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDaqApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CDaqApp commands
