//
//  DaqDir.cpp
//


#include "DaqDir.h"
#include "LogFile.h"


// ===================================================
//                  constructor
// ===================================================




// ==================================================
//
// ==================================================


int  DaqDir::setDir (DirNames dir, char* fname)
{

	switch ( dir )
	{

	case DataDir :
		_data = fname;
		logFile << "  Data dir:           " << _data << endl;
		break;
		
	case CtrlBlkDir :
		_ctrlBlk = fname;
		logFile << "  Control block dir:  " << _ctrlBlk << endl;
		break;
	
	case DetDir :
		_detectors = fname;
		logFile << "  Detectors dir:      " << _detectors << endl;
		break;

	case AutoPilotDir :
		_autoPilot = fname;
		logFile << "  AutoPilot dir:      " << _autoPilot << endl;
		break;
	
	}

	return 1;
	
}


// ==================================================
//
// ==================================================


int  DaqDir::getDir (DirNames dir, CString& path)
{

	switch ( dir )
	{

	case DataDir :
		path = _data;
		break;
		
	case CtrlBlkDir :
		path = _ctrlBlk;
		break;
	
	case DetDir :
		path = _detectors;
		break;

	case AutoPilotDir :
		path = _autoPilot;
		break;
	
	}

	return 1;
	
}

// ==================================================
//
// ==================================================


int  DaqDir::openFileDir (DirNames dir, char *fname, ofstream& file)
{


	CString  fileToOpen;

	
	switch ( dir )  {

	case DataDir :
		fileToOpen  = _data + "\\" + fname;
		break;
		
	case CtrlBlkDir :
		fileToOpen  = _ctrlBlk + "\\" + fname;
		break;
	
	case DetDir :
		fileToOpen  = _detectors + "\\" + fname;
		break;

	case AutoPilotDir :
		fileToOpen  = _autoPilot + "\\" + fname;
		break;

	case Local :
		fileToOpen  = fname;
		break;

	default :
		return 0;
		
	}

	
	file.open (fileToOpen, ios::out);

	if ( file == 0 )
		return 0;
	else
		return 1;

	logFile << "open file " << fileToOpen;


}



// ==================================================
//        open file to read
// ==================================================


int  DaqDir::openFileDirIn (DirNames dir, char *fname, ifstream& file)
{


	CString  fileToOpen;

	
	switch ( dir )  {

	case DataDir :
		fileToOpen  = _data + "\\" + fname;
		break;
		
	case CtrlBlkDir :
		fileToOpen  = _ctrlBlk + "\\" + fname;
		break;
	
	case DetDir :
		fileToOpen  = _detectors + "\\" + fname;
		break;

	case AutoPilotDir :
		fileToOpen  = _autoPilot + "\\" + fname;
		break;

	case Local :
		fileToOpen  = fname;
		break;

	default :
		return 0;
		
	}

	
	file.open (fileToOpen, ios::in);

	if ( file == 0 )
		return 0;
	else
		return 1;

	logFile << "open input file " << fileToOpen;


}


// ==================================================
//
// ==================================================


int  DaqDir::getFileDir (DirNames dir, char *fname, CString& fileNamePath)
{

	
	switch ( dir )  {

	case DataDir :
		fileNamePath  = _data + "\\" + fname;
		break;
		
	case CtrlBlkDir :
		fileNamePath  = _ctrlBlk + "\\" + fname;
		break;
	
	case DetDir :
		fileNamePath  = _detectors + "\\" + fname;
		break;

	case AutoPilotDir :
		fileNamePath  = _autoPilot + "\\" + fname;
		break;

	case Local :
		fileNamePath  = fname;
		break;

	default :
		return 0;
		
	}


	return 1;

}



