//
//  DetPlane.h
//


#ifndef _DETPLANE_H
#define _DETPLANE_H


#include "DspCard.h"
#include "Channels.h"
#include "Cal_DetPlane.h"
#include <afx.h>


class DetPlane
{


public :

	DetPlane (int, DspCard*);	
	~DetPlane ();	


	// ---------------------------------
	
	
	int   link ();
	int   dspNr ();

	void  init (char *); 	


	// ---------------------------------


	void  set_nChan (int);
	int   nChan ();

	void  set_counterValue (int);
	int   counterValue ();

	void  set_eventLength (int);
	int   eventLength ();

	void  set_hitType (int);
	int   hitType ();

	void  set_strobeDelay (int);
	int   strobeDelay ();

	void  set_nLoops (int);
	int   nLoops ();

	void  name (CString&);

	//  ----------------------	
	//          dac's
	//  ----------------------

	int  setV_thres (double);
	int  setV_ref   (double);
	int  setV_att   (double);
	int  setV_cal   (double);

	double  getV_thres ();
	double  getV_ref ();
	double  getV_att ();
	double  getV_cal ();

	// -------------------------
	//    controlBlocks
	// -------------------------

	CtrlBlock&    ctrlBlk;
	
	Channels      chanList;
	Cal_DetPlane  calib;


private :
	
	int      _link;
	CString  _planeName;

	int    _nChannels, _nChips;
	int    _counterValue, _eventLength;
	int    _hitType;
	int    _nLoops;


	DspCard*  _the_dsp;

};


#endif _DETPLANE_H
