//
//   DspCard.h
//


#ifndef _DSPCARD_H
#define _DSPCARD_H


#include "CtrlBlock.h"


class  DspCard 
{

public :

	DspCard (int);
	~DspCard ();


	// ------------------------------------
	//   base address of dsp,  init dsp
	// ------------------------------------

	int  address_base (unsigned short *address);
	int  init ();

	int  dspNr ();

	//  -------------
	//   dac's
	// --------------

	int     set_ll_dac  (int, double);
	int     set_sys_dac (int, double);
	double  get_ll_dac  (int);
	double  get_sys_dac (int);
	
	// -----------------
	//    strobe delay
	// -----------------

	int   set_strobe_delay (int);
	int   get_strobe_delay ();

	// -----------------
	//   counter value 
	// -----------------

	int   set_counterValue (int);
	int   get_counterValue ();


	// -----------------
	//    ctrl Blocks
	// -----------------

	CtrlBlock  ctrlBlk; 

	// -------------------
	//      flags
	// -------------------
	
	int setFlag (int, int);
	int getFlag (int);

	void verbFlagOn ();
	void verbFlagOff ();



private :


	double  _sysDac[4];
	double  _llDac[4];

	int     _strobeDelay;
	int     _counterValue;
	
	unsigned short  *_address_map;


	int     _dspNr;

};


#endif _DSPCARD_H
