//
//  QinjScan.cpp
//


#include "QinjScan.h"

#include <iostream.h>
#include <fstream.h>


// ===========================================
//       constructor
// ===========================================


QinjScan::QinjScan (double start, double stop, double stepSize, 
					  DetPlane*  detPlane)
					: Scan (start, stop, stepSize, detPlane)
{

	_detPlane = detPlane;

}					  


// ================================================
//        init
// ================================================


int QinjScan::init (double value)
{
	
	_detPlane->setV_thres (value);

	return 1;

}


// ================================================
//      setVariable
// ================================================


int QinjScan::setVariable (double* setValue)
{					  

	_detPlane->setV_cal (*setValue);
	*setValue = _detPlane->getV_cal ();
	
	return 2;
}


void  QinjScan::headerToFile (ofstream& outFile)
{

	outFile << "QinjScan (thres:) " <<  _detPlane->getV_thres () << endl;
}

