//
//   ReadOutConfig.h
//


#ifndef _READOUTCONFIG_H
#define _READOUTCONFIG_H


#include "DetPlane.h"
#include "DspCard.h"


class ReadoutConfig {


public :

	ReadoutConfig ();
	~ReadoutConfig ();


	// ---  detector planes  ----

	int  add_detPlane (int, int);
	int  remove_detPlane (int, int);
	int  nrOfPlanes ();

	DetPlane*  get_detPlane (int, int);


	// --- dsp card ----

	int  add_dspCard (int);
	int  remove_dspCard (int);

	DspCard*  get_dspCard (int);


	// --- readout list ---


	int       readoutList (int, int*, int*);
	DetPlane* readoutPlane (int);


private :

	
	DetPlane*   _detPlaneList [4];
	DspCard*    _dspCardList [1];

	int  _nr_of_detPlanes;
	int  *_linkList_forDetPlanes;
	int  *_dspList_forDetPlanes;

	void makeList ();

};



#endif _READOUTCONFIG_H