//
//   RunHandler.h
//


#ifndef _RUNHANDLER_H
#define _RUNHANDLER_H



#include  "DetPlane.h"


enum RunModes {thres, qinj, vref, vatt, strobe, 
			calib, source, noise, readout, none};



class RunHandler
{

 
public :

	RunHandler (DetPlane *);
	~RunHandler ();
	

	void setMode (RunModes);
	void setEvents (int);
	void setFileName (char*);
	void setEvents_fName (int, char*);

	void do_a_Run (double, double, double, double);

  
private :	
  
	int        _nEvents;
	char*      _fileName;
	RunModes   _mode;
	DetPlane*  _detPlane;

	int        fileName_to_logFile (char *);



};


#endif _RUNHANDLER_H