//
//  ScanData.h
//


#ifndef _SCANDATA_H
#define _SCANDATA_H


#include <iostream.h>
#include <fstream.h>

#include "Channels.h"


class ScanData
{


public :

	//  constructor,  destructor

	ScanData (double, double, double, int, Channels &);
  
	~ScanData ();


	//  Index

	void    resetPoint ();
	int     nextPoint  ();


	// access data points

	double  getPoint    ();                 // return point for _currPoint
	void    setPoint    (double);           // set point for _currPoint
	void    setPoint    (double, double);   // set point and events for _currPoint

	double  getEvents ();   // returns events for _currPoint
	


	//  access data

	unsigned int*  dataProjection ();      //  pointer data for one point

	int            scanProjection (double *, int);
	void           dataOut (ofstream &);
	void           dataOutGnu (char *);


	//  -----------------

	int     nPoints ();               // returns number of points
	void    printScanPara ();
  
  
private :
  
	double*  _points;
	double*  _events;

	unsigned int*  _data;
	unsigned int*  _scanProject;

	int      _nPoints, _nChannels;
	int      _currPoint;              //  (0 <= _currPoint < _nPoints)
	
	Channels* _chanList;


};


#endif _SCANDATA_H