//
//  StrobeScan.cpp
//


#include "StrobeScan.h"

#include <iostream.h>
#include <fstream.h>


// ===========================================
//       constructor
// ===========================================


StrobeScan::StrobeScan (double start, double stop, double stepSize, 
					  DetPlane*  detPlane)
					: Scan (start, stop, stepSize, detPlane)
{

	_detPlane = detPlane;

}					  


// ================================================
//        init
// ================================================


int StrobeScan::init (double valueVcal)
{

	_detPlane->setV_cal (valueVcal);


	return 1;

}


// ================================================
//      setVariable
// ================================================


int StrobeScan::setVariable (double* setValue)
{					  

	int  valueToSet;

	valueToSet = (int) *setValue;

	_detPlane->set_strobeDelay (valueToSet);

	valueToSet = _detPlane->strobeDelay ();

	*setValue = (double) valueToSet;
	

	return 2;
}


// =====================================================
//      write header line
// =====================================================


void  StrobeScan::headerToFile (ofstream& outFile)
{


	outFile << "StrobeDelayScan (thres/Vcal:) " <<  _detPlane->getV_thres () << 
		       "  " <<  _detPlane->getV_cal ()  << endl;

}

