//
//  ThreshScan.cpp
//


#include "ThreshScan.h"

#include <iostream.h>
#include <fstream.h>


// ===========================================
//       constructor
// ===========================================


ThreshScan::ThreshScan (double start, double stop, double stepSize, 
					  DetPlane*  detPlane)
					: Scan (start, stop, stepSize, detPlane)
{

	_detPlane = detPlane;

}					  


// ================================================
//        init
// ================================================


int ThreshScan::init (double value)
{
	
	_detPlane->setV_cal (value);

	return 1;

}


// ================================================
//      setVariable
// ================================================


int ThreshScan::setVariable (double* setValue)
{					  

	_detPlane->setV_thres (*setValue);
	*setValue = _detPlane->getV_thres ();
	
	return 2;
}


// ===============================================
//     write header line
// ===============================================


void  ThreshScan::headerToFile (ofstream& outFile)
{

	outFile << "ThresScan (Vcal:) " <<  _detPlane->getV_cal ()   << endl;

}
