//
//  VrefScan.cpp
//


#include "VrefScan.h"

#include <iostream.h>
#include <fstream.h>


// ===========================================
//       constructor
// ===========================================


VrefScan::VrefScan (double start, double stop, double stepSize, 
					  DetPlane*  detPlane)
					: Scan (start, stop, stepSize, detPlane)
{

	_detPlane = detPlane;

}					  


// ================================================
//        init
// ================================================


int VrefScan::init (double value)
{
	
	return 1;

}


// ================================================
//      setVariable
// ================================================


int VrefScan::setVariable (double* setValue)
{					  

	_detPlane->setV_ref (*setValue);
	*setValue = _detPlane->getV_ref ();
	
	return 2;
}


// ===============================================
//     write header line
// ===============================================


void  VrefScan::headerToFile (ofstream& outFile)
{


	outFile << "VrefScan (thres/Vcal:) " <<  _detPlane->getV_thres () << 
		       "  "                      <<  _detPlane->getV_cal ()   << endl;

}
